diff --git a/controller/encaps.c b/controller/encaps.c
index 9647ba507..e6b2aa074 100644
--- a/controller/encaps.c
+++ b/controller/encaps.c
@@ -75,7 +75,8 @@ tunnel_create_name(struct tunnel_ctx *tc, const char *chassis_id)
 
     for (i = 0; i < UINT16_MAX; i++) {
         char *port_name;
-        port_name = xasprintf("ovn-%.6s-%x", chassis_id, i);
+        port_name = xasprintf(
+            "ovn-%s-%s-%x", tc->this_chassis->name, chassis_id, i);
 
         if (!sset_contains(&tc->port_names, port_name)) {
             return port_name;
diff --git a/tests/ovn-controller.at b/tests/ovn-controller.at
index 3c3fb31c7..d6a2cbb49 100644
--- a/tests/ovn-controller.at
+++ b/tests/ovn-controller.at
@@ -261,7 +261,7 @@ ovs-vsctl \
 ovn_attach n1 br-phys 192.168.0.1
 
 check_tunnel_property () {
-    test "`ovs-vsctl get interface ovn-fakech-0 $1`" = "$2"
+    test "`ovs-vsctl get interface ovn-hv-fakechassis-0 $1`" = "$2"
 }
 
 # create "empty" chassis. vxlan is used here as a stub
@@ -273,8 +273,8 @@ ovn-sbctl chassis-add fakechassis vxlan 192.168.0.2
 # the chassis-id in ovn-chassis-id); if we supply a different IP here
 # we won't be able to co-relate this to the tunnel port that was created
 # in the previous step and, as a result, will end up creating another tunnel,
-# ie. we can't just lookup using "ovn-fakech-0". So, need to use the same IP
-# as above, i.e 192.168.0.2, here.
+# ie. we can't just lookup using "ovn-hv-fakechassis-0". So, need to use the
+# same IP as above, i.e 192.168.0.2, here.
 encap_uuid=$(ovn-sbctl add chassis fakechassis encaps @encap -- --id=@encap create encap type=geneve ip="192.168.0.2")
 OVS_WAIT_UNTIL([check_tunnel_property type geneve])
 
@@ -292,11 +292,11 @@ ovn-sbctl set encap ${encap_uuid} ip=192.168.0.2
 OVS_WAIT_UNTIL([check_tunnel_property options:remote_ip "\"192.168.0.2\""])
 
 # Change the type on the OVS side and check than OVN fixes it
-ovs-vsctl set interface ovn-fakech-0 type=vxlan
+ovs-vsctl set interface ovn-hv-fakechassis-0 type=vxlan
 OVS_WAIT_UNTIL([check_tunnel_property type geneve])
 
 # Delete the port entirely and it should be resurrected
-ovs-vsctl del-port ovn-fakech-0
+ovs-vsctl del-port ovn-hv-fakechassis-0
 OVS_WAIT_UNTIL([check_tunnel_property type geneve])
 
 # set `ovn-set-local-ip` option to true and check if tunnel parameters
@@ -305,7 +305,7 @@ ovs-vsctl set open . external_ids:ovn-set-local-ip=true
 OVS_WAIT_UNTIL([check_tunnel_property options:local_ip "\"192.168.0.1\""])
 
 # Change the local_ip on the OVS side and check than OVN fixes it
-ovs-vsctl set interface ovn-fakech-0 options:local_ip="1.1.1.1"
+ovs-vsctl set interface ovn-hv-fakechassis-0 options:local_ip="1.1.1.1"
 OVS_WAIT_UNTIL([check_tunnel_property options:local_ip "\"192.168.0.1\""])
 
 # Gracefully terminate daemons
@@ -769,7 +769,7 @@ ovs-vsctl \
 ovn_attach n1 br-phys 192.168.0.1
 
 check_tunnel_property () {
-    test "`ovs-vsctl get interface ovn-fakech-0 $1`" = "$2"
+    test "`ovs-vsctl get interface ovn-hv-fakechassis-0 $1`" = "$2"
 }
 
 # without any tos options
@@ -780,7 +780,7 @@ no_tos_options="{csum=\"true\", key=flow, remote_ip=\"192.168.0.2\"}"
 ovn-sbctl chassis-add fakechassis geneve 192.168.0.2
 OVS_WAIT_UNTIL([check_tunnel_property type geneve])
 
-tos_option=$(ovs-vsctl get interface ovn-fakech-0 options)
+tos_option=$(ovs-vsctl get interface ovn-hv-fakechassis-0 options)
 AT_CHECK([test "$tos_option" = "$no_tos_options"], [0], [])
 
 expected_tos_option="inherit"
@@ -791,7 +791,7 @@ ovs-vsctl \
 # now, wait for a sec
 sleep 1
 
-tos_option=$(ovs-vsctl get interface ovn-fakech-0 options:tos)
+tos_option=$(ovs-vsctl get interface ovn-hv-fakechassis-0 options:tos)
 AT_CHECK([test "$tos_option" = "$expected_tos_option"], [0], [])
 
 # Try another value
@@ -803,7 +803,7 @@ ovs-vsctl \
 # now, wait for a sec
 sleep 1
 
-tos_option=$(ovs-vsctl get interface ovn-fakech-0 options:tos)
+tos_option=$(ovs-vsctl get interface ovn-hv-fakechassis-0 options:tos)
 AT_CHECK([test "$tos_option" = "\"$expected_tos_option\""], [0], [])
 
 # Remove tos option and check if we are back to the original state
@@ -814,7 +814,7 @@ ovs-vsctl \
 # now, wait for a sec
 sleep 1
 
-tos_option=$(ovs-vsctl get interface ovn-fakech-0 options)
+tos_option=$(ovs-vsctl get interface ovn-hv-fakechassis-0 options)
 AT_CHECK([test "$tos_option" = "$no_tos_options"], [0], [])
 
 # Gracefully terminate daemons
diff --git a/tests/ovn-ipsec.at b/tests/ovn-ipsec.at
index 10ef97878..a2e185f33 100644
--- a/tests/ovn-ipsec.at
+++ b/tests/ovn-ipsec.at
@@ -48,14 +48,14 @@ ovn-nbctl set nb_global . options:ipsec_encapsulation=true
 
 check ovn-nbctl --wait=hv sync
 
-AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv1-0 options:remote_ip | tr -d '"\n'], [0], [192.168.0.1])
-AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv1-0 options:local_ip | tr -d '"\n'], [0], [192.168.0.2])
-AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv1-0 options:remote_name | tr -d '\n'], [0], [hv1])
-AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv1-0 options:ipsec_encapsulation | tr -d '\n'], [0], [yes])
-AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv2-0 options:remote_ip | tr -d '"\n'], [0], [192.168.0.2])
-AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv2-0 options:local_ip | tr -d '"\n'], [0], [192.168.0.1])
-AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv2-0 options:remote_name | tr -d '\n'], [0], [hv2])
-AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv2-0 options:ipsec_encapsulation | tr -d '\n'], [0], [yes])
+AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv2-hv1-0 options:remote_ip | tr -d '"\n'], [0], [192.168.0.1])
+AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv2-hv1-0 options:local_ip | tr -d '"\n'], [0], [192.168.0.2])
+AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv2-hv1-0 options:remote_name | tr -d '\n'], [0], [hv1])
+AT_CHECK([as hv2 ovs-vsctl get Interface ovn-hv2-hv1-0 options:ipsec_encapsulation | tr -d '\n'], [0], [yes])
+AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv1-hv2-0 options:remote_ip | tr -d '"\n'], [0], [192.168.0.2])
+AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv1-hv2-0 options:local_ip | tr -d '"\n'], [0], [192.168.0.1])
+AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv1-hv2-0 options:remote_name | tr -d '\n'], [0], [hv2])
+AT_CHECK([as hv1 ovs-vsctl get Interface ovn-hv1-hv2-0 options:ipsec_encapsulation | tr -d '\n'], [0], [yes])
 
 AT_CLEANUP
 
diff --git a/tests/ovn-performance.at b/tests/ovn-performance.at
index 9affca498..5c0267a88 100644
--- a/tests/ovn-performance.at
+++ b/tests/ovn-performance.at
@@ -251,7 +251,7 @@ for i in `seq 1 5`; do
     for j in `seq 1 5`; do
         if [[ $i -ne $j ]] ; then
             OVS_WAIT_UNTIL([
-                test $(as hv$i ovs-vsctl list interface ovn-hv$j-0 | \
+                test $(as hv$i ovs-vsctl list interface ovn-hv$i-hv$j-0 | \
             grep -c tunnel_egress_iface_carrier=up) -eq 1
             ])
         fi
@@ -519,7 +519,7 @@ OVN_CONTROLLER_EXPECT_HIT(
 
 # Make hv4 master. There is remote possibility that full recompute
 # triggers for hv1-hv5 after hv4 becomes master because of updates to the
-# ovn-hv$i-0 interfaces. Most of the time there will be no recompute.
+# ovn-hv$i-hv$j-0 interfaces. Most of the time there will be no recompute.
 ovn-nbctl --wait=hv lrp-set-gateway-chassis lr1-public hv4 40
 hv4_ch=$(ovn-sbctl --bare --columns _uuid list chassis hv4)
 OVS_WAIT_UNTIL([ovn-sbctl find port_binding logical_port=cr-lr1-public chassis=$hv4_ch])
diff --git a/tests/ovn.at b/tests/ovn.at
index 80e9192ca..c03ff4f17 100644
--- a/tests/ovn.at
+++ b/tests/ovn.at
@@ -11007,8 +11007,8 @@ AT_CHECK([ovn-nbctl --wait=sb sync], [0], [ignore])
 ovn-sbctl dump-flows > sbflows
 AT_CAPTURE_FILE([sbflows])
 
-hv1_gw1_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw1-0)
-hv1_gw2_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw2-0)
+hv1_gw1_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-gw1-0)
+hv1_gw2_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-gw2-0)
 
 OVS_WAIT_UNTIL([
     test 1 = $(as hv1 ovs-ofctl dump-flows br-int table=37 | grep -c "active_backup,ofport,members:$hv1_gw1_ofport,$hv1_gw2_ofport")
@@ -11141,7 +11141,7 @@ AT_CHECK([test $gw2_claim_ct = `cat gw2/ovn-controller.log | \
 grep -c "cr-alice: Claiming"`])
 
 OVS_WAIT_UNTIL([
-    bfd_status=$(as hv1 ovs-vsctl get interface ovn-gw2-0 bfd_status:state)
+    bfd_status=$(as hv1 ovs-vsctl get interface ovn-hv1-gw2-0 bfd_status:state)
     echo "bfd status = $bfd_status"
     test "$bfd_status" = "down"
 ])
@@ -11291,8 +11291,8 @@ wait_column "$hv1_ch_uuid" HA_Chassis_Group ref_chassis
 # Allow some time for ovn-northd and ovn-controller to catch up.
 check ovn-nbctl --wait=hv sync
 
-hv1_gw1_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw1-0)
-hv1_gw2_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw2-0)
+hv1_gw1_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-gw1-0)
+hv1_gw2_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-gw2-0)
 
 OVS_WAIT_UNTIL([
     test 1 = $(as hv1 ovs-ofctl dump-flows br-int table=37 | grep -c "active_backup,ofport,members:$hv1_gw1_ofport,$hv1_gw2_ofport")
@@ -13039,10 +13039,10 @@ bfd_dump() {
 
 bfd_dump
 
-hv1_gw1_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw1-0)
-hv1_gw2_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw2-0)
-hv2_gw1_ofport=$(as hv2 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw1-0)
-hv2_gw2_ofport=$(as hv2 ovs-vsctl --bare --columns ofport find Interface name=ovn-gw2-0)
+hv1_gw1_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-gw1-0)
+hv1_gw2_ofport=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-gw2-0)
+hv2_gw1_ofport=$(as hv2 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv2-gw1-0)
+hv2_gw2_ofport=$(as hv2 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv2-gw2-0)
 
 echo $hv1_gw1_ofport
 echo $hv1_gw2_ofport
@@ -13121,7 +13121,7 @@ wait_row_count Port_Binding 1 logical_port=cr-outside chassis=$gw2_chassis
 as gw1
 for chassis in gw2 hv1 hv2; do
     echo "checking gw1 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-gw1-$chassis-0],[0],
              [[enable=true
 ]])
 done
@@ -13131,7 +13131,7 @@ done
 as gw2
 for chassis in gw1 hv1 hv2; do
     echo "checking gw2 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-gw2-$chassis-0],[0],
              [[enable=true
 ]])
 done
@@ -13140,12 +13140,12 @@ done
 as hv1
 for chassis in gw1 gw2; do
     echo "checking hv1 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv1-$chassis-0],[0],
              [[enable=true
 ]])
 done
 # make sure BFD is not enabled to hv2, we don't need it
-AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-0],[0],
+AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv1-hv2-0],[0],
          [[
 ]])
 
@@ -13154,12 +13154,12 @@ AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-0],[0],
 as hv2
 for chassis in gw1 gw2; do
     echo "checking hv2 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-$chassis-0],[0],
              [[enable=true
 ]])
 done
 # make sure BFD is not enabled to hv1, we don't need it
-AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv1-0],[0],
+AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-hv1-0],[0],
          [[
 ]])
 
@@ -13194,7 +13194,7 @@ as gw2
 for chassis in gw1 hv1 hv2; do
     echo "checking gw2 -> $chassis"
     OVS_WAIT_UNTIL([
-    bfd_cfg=$(ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0)
+    bfd_cfg=$(ovs-vsctl --bare --columns bfd find Interface name=ovn-gw2-$chassis-0)
     test "$bfd_cfg" = "enable=true min_rx=2000"
 ])
 done
@@ -13202,7 +13202,7 @@ ovn-nbctl --wait=hv set NB_Global . options:"bfd-min-tx"=1500
 for chassis in gw1 hv1 hv2; do
     echo "checking gw2 -> $chassis"
     OVS_WAIT_UNTIL([
-    bfd_cfg=$(ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0)
+    bfd_cfg=$(ovs-vsctl --bare --columns bfd find Interface name=ovn-gw2-$chassis-0)
     test "$bfd_cfg" = "enable=true min_rx=2000 min_tx=1500"
 ])
 done
@@ -13211,7 +13211,7 @@ ovn-nbctl --wait=hv set NB_Global . options:"bfd-mult"=5
 for chassis in gw1 hv1 hv2; do
     echo "checking gw2 -> $chassis"
     OVS_WAIT_UNTIL([
-    bfd_cfg=$(ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0)
+    bfd_cfg=$(ovs-vsctl --bare --columns bfd find Interface name=ovn-gw2-$chassis-0)
     test "$bfd_cfg" = "enable=true min_tx=1500 mult=5"
 ])
 done
@@ -13347,7 +13347,7 @@ grep active_backup | grep slaves:$hv2_gw2_ofport,$hv2_gw1_ofport \
 as gw1
 for chassis in gw2 hv1 hv2; do
     echo "checking gw1 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-gw1-$chassis-0],[0],
              [[enable=true
 ]])
 done
@@ -13356,7 +13356,7 @@ done
 as gw2
 for chassis in gw1 hv1 hv2; do
     echo "checking gw2 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-gw2-$chassis-0],[0],
              [[enable=true
 ]])
 done
@@ -13365,12 +13365,12 @@ done
 as hv1
 for chassis in gw1 gw2; do
     echo "checking hv1 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv1-$chassis-0],[0],
              [[enable=true
 ]])
 done
 # make sure BFD is not enabled to hv2, we don't need it
-AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-0],[0],
+AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv1-hv2-0],[0],
          [[
 ]])
 
@@ -13378,12 +13378,12 @@ AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-0],[0],
 as hv2
 for chassis in gw1 gw2; do
     echo "checking hv2 -> $chassis"
-    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-$chassis-0],[0],
+    AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-$chassis-0],[0],
              [[enable=true
 ]])
 done
 # make sure BFD is not enabled to hv1, we don't need it
-AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv1-0],[0],
+AT_CHECK([ovs-vsctl --bare --columns bfd find Interface name=ovn-hv2-hv1-0],[0],
          [[
 ]])
 
@@ -19690,42 +19690,42 @@ check ovn-nbctl --wait=hv sync
 dnl Assert that each Chassis has a tunnel formed to every other Chassis
 as hv1
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv2-0
-ovn-hv3-0
-ovn-hv4-0
-ovn-hv5-0
+[[ovn-hv1-hv2-0
+ovn-hv1-hv3-0
+ovn-hv1-hv4-0
+ovn-hv1-hv5-0
 ]])
 
 as hv2
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv3-0
-ovn-hv4-0
-ovn-hv5-0
+[[ovn-hv2-hv1-0
+ovn-hv2-hv3-0
+ovn-hv2-hv4-0
+ovn-hv2-hv5-0
 ]])
 
 as hv3
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv2-0
-ovn-hv4-0
-ovn-hv5-0
+[[ovn-hv3-hv1-0
+ovn-hv3-hv2-0
+ovn-hv3-hv4-0
+ovn-hv3-hv5-0
 ]])
 
 as hv4
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv2-0
-ovn-hv3-0
-ovn-hv5-0
+[[ovn-hv4-hv1-0
+ovn-hv4-hv2-0
+ovn-hv4-hv3-0
+ovn-hv4-hv5-0
 ]])
 
 as hv5
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv2-0
-ovn-hv3-0
-ovn-hv4-0
+[[ovn-hv5-hv1-0
+ovn-hv5-hv2-0
+ovn-hv5-hv3-0
+ovn-hv5-hv4-0
 ]])
 
 dnl Let's now add some Chassis to different transport zones
@@ -19756,28 +19756,28 @@ check ovn-nbctl --wait=hv sync
 
 as hv1
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv2-0
-ovn-hv3-0
+[[ovn-hv1-hv2-0
+ovn-hv1-hv3-0
 ]])
 
 as hv2
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
+[[ovn-hv2-hv1-0
 ]])
 
 as hv3
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
+[[ovn-hv3-hv1-0
 ]])
 
 as hv4
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv5-0
+[[ovn-hv4-hv5-0
 ]])
 
 as hv5
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv4-0
+[[ovn-hv5-hv4-0
 ]])
 
 dnl Removing the transport zones should make all Chassis to create
@@ -19792,42 +19792,42 @@ check ovn-nbctl --wait=hv sync
 
 as hv1
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv2-0
-ovn-hv3-0
-ovn-hv4-0
-ovn-hv5-0
+[[ovn-hv1-hv2-0
+ovn-hv1-hv3-0
+ovn-hv1-hv4-0
+ovn-hv1-hv5-0
 ]])
 
 as hv2
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv3-0
-ovn-hv4-0
-ovn-hv5-0
+[[ovn-hv2-hv1-0
+ovn-hv2-hv3-0
+ovn-hv2-hv4-0
+ovn-hv2-hv5-0
 ]])
 
 as hv3
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv2-0
-ovn-hv4-0
-ovn-hv5-0
+[[ovn-hv3-hv1-0
+ovn-hv3-hv2-0
+ovn-hv3-hv4-0
+ovn-hv3-hv5-0
 ]])
 
 as hv4
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv2-0
-ovn-hv3-0
-ovn-hv5-0
+[[ovn-hv4-hv1-0
+ovn-hv4-hv2-0
+ovn-hv4-hv3-0
+ovn-hv4-hv5-0
 ]])
 
 as hv5
 AT_CHECK([ovs-vsctl --bare --columns=name find interface type="geneve" | awk NF | sort], [0],
-[[ovn-hv1-0
-ovn-hv2-0
-ovn-hv3-0
-ovn-hv4-0
+[[ovn-hv5-hv1-0
+ovn-hv5-hv2-0
+ovn-hv5-hv3-0
+ovn-hv5-hv4-0
 ]])
 
 OVN_CLEANUP([hv1], [hv2], [hv3])
@@ -25690,14 +25690,14 @@ check ovn-nbctl fwd-group-del fwd_grp1
 check ovn-nbctl --wait=hv --liveness fwd-group-add fwd_grp1 ls2 172.16.1.11 00:11:de:ad:be:ef lsp21 lsp22
 
 # Verify openflow group members
-ofport_lsp21=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv2-0)
+ofport_lsp21=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-hv2-0)
 tunnel_key=`ovn-sbctl --bare --column tunnel_key find port_binding logical_port=lsp21`
 AT_CHECK([as hv1 ovs-ofctl -O OpenFlow13 dump-groups br-int | \
     grep "bucket=watch_port:$ofport_lsp21,actions=load:0x"$tunnel_key | wc -l], [0], [dnl
 1
 ])
 
-ofport_lsp22=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv3-0)
+ofport_lsp22=$(as hv1 ovs-vsctl --bare --columns ofport find Interface name=ovn-hv1-hv3-0)
 tunnel_key=`ovn-sbctl --bare --column tunnel_key find port_binding logical_port=lsp22`
 AT_CHECK([as hv1 ovs-ofctl -O OpenFlow13 dump-groups br-int | \
     grep "bucket=watch_port:$ofport_lsp22,actions=load:0x"$tunnel_key | wc -l], [0], [dnl